<?php

namespace Modules\St\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;

class OutsideFactory extends Model
{
    protected $table = 'st_outside_factories';
    protected $primaryKey = "outside_factory_id";
    use HasFactory,LogsActivity;
    protected static $logAttributes = [
        'outside_factory_id',
        'factory_id',
        'name',
        'supplier_id',
        'status',
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "st_outside_factories";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
    
    protected static function newFactory()
    {
        return \Modules\St\Database\factories\OutsideFactoryFactory::new();
    }
}
