<?php

namespace Modules\St\Entities;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Support\Facades\Auth;
use Spatie\Activitylog\Contracts\Activity;
use Spatie\Activitylog\Traits\LogsActivity;
class SupplierContact extends Model
{
    protected $table = 'st_supplier_contacts';
    protected $primaryKey = 'contact_id';
    protected $keyType = 'string';
    use HasFactory,LogsActivity;
    protected static $logAttributes = [
        'contact_id',
        'supplier_foriegn_id',
        'designation',
        'email',
        'mobile',
        'fixed',
        'sms_alert',
        'email_alert',
        'primary_contact',
    ];
    protected static $logOnlyDirty = true;
    public function tapActivity(Activity $activity, string $eventName)
    {
        $activity->log_name = "st_supplier_contacts";
        $activity->description = $eventName;
        $activity->causer_id = Auth::user()->id;
    }
    // protected $fillable = [];
    
    // protected static function newFactory()
    // {
    //     return \Modules\St\Database\factories\SupplierContactFactory::new();
    // }
}
