<?php

namespace Modules\St\Http\Controllers;

use Exception;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\St\Entities\EmailGroupData;
use Modules\St\Entities\EmailGroupHeader;

class EmailGroupController extends Controller
{

    public function allGroup()
    {
        try {
            $Groups =  EmailGroupHeader::all();
            $responseBody = $this->responseBody(true, "EmailGroupController", "allGroup", $Groups);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "EmailGroupController", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }




    public function saveEmail(Request $request)
    {
        try {
            $group_id = $request->get('group_id');
            $email = $request->get('email');
            $name = $request->get('name');

            $group_data = new EmailGroupData();
            $group_data->email_group_id = $group_id;
            $group_data->name = $name;
            $group_data->email = $email;
            $group_data->status = 1;
            $group_data->save();
            $responseBody = $this->responseBody(true, "EmailGroupController", "saveEmail", true);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "EmailGroupController", "saveEmail", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function getAllEmails($group_id)
    {
        try {
            $Group_data =  EmailGroupData::where('email_group_id', '=', $group_id)->get();
            $responseBody = $this->responseBody(true, "EmailGroupController", "getAllEmails", $Group_data);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "EmailGroupController", "getAllEmails", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    public function change_status_email($id)
    {
        try {
            $Group_data =  EmailGroupData::find($id);
            if ($Group_data) {
                if ($Group_data->status == 1) {
                    $Group_data->status = 0;
                } else if ($Group_data->status == 0) {
                    $Group_data->status = 1;
                }
                $Group_data->update();
            }
            $responseBody = $this->responseBody(true, "EmailGroupController", "getAllEmails", $Group_data);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "EmailGroupController", "getAllEmails", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }




    public function deleteEmail($id)
    {
        try {
            EmailGroupData::find($id)->delete();
            $responseBody = $this->responseBody(true, "EmailGroupController", "deleteEmail", true);
        } catch (Exception $exception) {
            $responseBody = $this->responseBody(false, "EmailGroupController", "deleteEmail", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }



    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
