<?php

namespace Modules\St\Http\Controllers;

use App\Models\Notification;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Modules\St\Entities\ApprovalRollback;
use Modules\St\Entities\ApprovalTask;

class UserApprovalRequestController extends Controller
{
    /**
     * Display a listing of the resource.
     * @return Renderable
     */
    public function index()
    {
        return view('st::index');
    }

    /**
     * Show the form for creating a new resource.
     * @return Renderable
     */
    public function create()
    {
        return view('st::create');
    }

    /**
     * Store a newly created resource in storage.
     * @param Request $request
     * @return Renderable
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Show the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function show($id)
    {
        return view('st::show');
    }

    /**
     * Show the form for editing the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function edit($id)
    {
        return view('st::edit');
    }

    /**
     * Update the specified resource in storage.
     * @param Request $request
     * @param int $id
     * @return Renderable
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     * @param int $id
     * @return Renderable
     */
    public function destroy($id)
    {
        //
    }


    public static function isApproval($slug)
    {
        $query = "SELECT * FROM
        `permissions` permissions INNER JOIN `st_approval_rules` st_approval_rules ON permissions.`id` = st_approval_rules.`slug_id` WHERE permissions.`slug` = '" . $slug . "'";
        $result = DB::select($query);
        if ($result) {
            return true;
        }
        return false;
    }


    public static function send($slug, $object)
    {

        $query = "SELECT
            st_approval_rules.`id` AS id,
            st_approval_rules.`description` AS description,
            st_approval_rules.`message` AS message,
            st_approval_rules.`prioraty` AS prioraty,
            st_approval_rules.`user_id` AS user_id,
            st_approval_rules.`designation_id` AS designation_id
       FROM
            `st_approval_rules` st_approval_rules INNER JOIN `permissions` permissions ON st_approval_rules.`slug_id` = permissions.`id` WHERE permissions.`slug` = '" . $slug . "' ORDER BY st_approval_rules.`prioraty` ASC";
        $result = DB::select($query);


        /** RollBack */
        $array = $object->toArray();
        /*$str_array = json_encode($array);
        $rollback = new ApprovalRollback();
        $rollback->sql = $str_array;
        $rollback->status = true;
        $rollback->date = date('Y-m-d');
        $rollback->save();*/

        $query2 = "SELECT 
        `column_comment` AS field_name,
        `column_name`
        from `information_schema`.`COLUMNS` 
        where `table_name` = 'hr_employees' 
        and `table_schema` = 'erp_riococo_salary3'";

        $result2 = DB::select($query2);


        $rand_id = rand();
        foreach ($result2 as $record) {
            $rollback = new ApprovalRollback();
            $rollback->user_id = Auth::user()->id;
            $rollback->column_name = $record->column_name;
            $rollback->field_name = $record->field_name;
            if ($record->column_name == "created_at" || $record->column_name == "updated_at") {
                $rollback->value = "";
            } else {
                $rollback->value = $array[$record->column_name];
            }

            $rollback->rand_id = $rand_id;
            $rollback->status = 1;
            $bool = $rollback->save();
        }
        /** End of RollBack */

        foreach ($result as $approval) {
            $task = new ApprovalTask();
            $task->approval_rule_id = $approval->id;
            $task->approval_rollback_id = $rand_id;
            $task->is_approval = false;
            $task->save();

            $notification = new  Notification();
            $notification->sender_id = Auth::user()->id;
            $notification->recipient_id = $approval->user_id;
            $notification->icon_id = NULL;
            $notification->title_html = NULL;
            $notification->body_html = $approval->message;
            $notification->route = '/st/approvalList';
            $notification->is_unread = false;
            $notification->is_hidden = false;
            $notification->save();
        }
    }
}
