<?php

namespace Modules\St\Http\Controllers;

use Exception;
use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\St\Entities\Role;
use Modules\St\Entities\UserRole;

class UserRoleController extends Controller
{
    /**
     * Display a listing of the resource.
     * @return Renderable
     */
    public function index()
    {
        return view('st::index');
    }

    /**
     * Show the form for creating a new resource.
     * @return Renderable
     */
    public function create()
    {
        return view('st::create');
    }

    /**
     * Store a newly created resource in storage.
     * @param Request $request
     * @return Renderable
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Show the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function show($id)
    {
        return view('st::show');
    }

    /**
     * Show the form for editing the specified resource.
     * @param int $id
     * @return Renderable
     */
    public function edit($id)
    {
        return view('st::edit');
    }

    /**
     * Update the specified resource in storage.
     * @param Request $request
     * @param int $id
     * @return Renderable
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     * @param int $id
     * @return Renderable
     */
    public function destroy($id)
    {
        //
    }



    public function save(Request $request)
    {

        try {
            $userRole = new Role();
            $userRole->name = $request->get('userRole');
            $userRole->slug = '';
            $save = $userRole->save();
            if ($save) {
                $responseBody = $this->responseBody(true, "Role", "saved", null);
            } else {
                $responseBody = $this->responseBody(false, "Role", "saved", $save);
            }
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "Role", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }




    public function allUserRole()
    {
        try {
            $roles =  Role::all();
            $responseBody = $this->responseBody(true, "Role", "all", $roles);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "Role", "error", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }






    public function getUserRole($id)
    {

        $userRole = Role::find($id);
        return response()->json(["data" =>  $this->responseBody(true, "Role", "getUserRole", $userRole)]);
    }



    public function deleteUserRole($id)
    {
        try {
            $userRole = Role::find($id);
            $delete = $userRole->delete();
            if ($delete) {
                $responseBody = $this->responseBody(true, "UserRole", "deleted", null);
            } else {
                $responseBody = $this->responseBody(false, "UserRole", "saved", $delete);
            }
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "UserRole", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }



    public function updateUserRole(Request $request, $id)
    {
        try {
            $userRole = Role::find($id);
            $userRole->name = $request->get('userRole');
            $save = $userRole->save();
            if ($save) {
                $responseBody = $this->responseBody(true, "Role", "updated", null);
            } else {
                $responseBody = $this->responseBody(false, "Role", "updated", $save);
            }
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "Role", "error", $exception);
        }

        return response()->json(["data" => $responseBody]);
    }




    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
