
$(document).ready(function () {
    allModulesApproval();
    allDesignation();
    allEmployees();
    $('#selcDesignation').prop("disabled", true);
    $('#txtUser').prop("disabled", true);
    $('#btnAdd').prop("disabled", true);

    $('#cmbApprovalModule').on('change', function () {
        var id = $(this).val();
        allApprovals(id);
    });


    $('#btnApprovalAction').on('click', function (event) {

        var data = getData();
        var event = $(this).text();

        if (event == 'Save') {
            saveApproval(data);
        } else if (event == 'Update') {
            updateApproval(data);
        }
    });

    $('#checkDesignationSearch').on('change', function () {
        var bool = $(this).is(':checked');
        if (bool) {
            $('#selcDesignation').prop("disabled", false);
            $('#btnAdd').prop("disabled", false);
            $('#checkUserSearch').prop('checked', false);
            $('#txtUser').prop("disabled", true);
        } else {
            $('#selcDesignation').prop("disabled", true);
            $('#btnAdd').prop("disabled", true);
        }
    });

    $('#checkUserSearch').on('change', function () {
        var bool = $(this).is(':checked');
        if (bool) {
            $('#txtUser').prop("disabled", false);
            $('#btnAdd').prop("disabled", false);
            $('#checkDesignationSearch').prop('checked', false);
            $('#selcDesignation').prop("disabled", true);
        } else {
            $('#txtUser').prop("disabled", true);
            $('#btnAdd').prop("disabled", true);
        }
    });


    $('#btnAdd').on('click', function () {

        var value = "";
        if ($('#checkDesignationSearch').is(':checked')) {
            value = $('#selcDesignation').val();
        }

        if ($('#checkUserSearch').is(':checked')) {
            value = $('#txtUser').optionID();
        }

        var bool = isExistingValue(value);
        if (!bool) {
            addTableValue();
        } else {
            var message = "";
            if ($('#checkDesignationSearch').is(':checked')) {
                message = $('select[name=designation] option:selected').text();
            }

            if ($('#checkUserSearch').is(':checked')) {
                message = $('#txtUser').val();
            }
            message += " already exists";
            showWarningMessage(message);
        }
    });

});

function allModulesApproval() {
    $.ajax({
        type: "GET",
        url: "/st/user/setting/allModules",
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {

                appendComboOptionApproval(response.data.result);
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}



function appendComboOptionApproval(result) {

    $('#cmbApprovalModule').empty();
    $('#cmbApprovalModule').append('<option value="disable" disabled>--Select Module--</option>');
    for (i = 0; i < result.length; i++) {
        $('#cmbApprovalModule').append('<option value="' + result[i].id + '">' + result[i].module_name + '</option>');
    }
    let element = document.getElementById('cmbApprovalModule');
    element.value = "disable";
}




function allApprovals(module_id) {
    $.ajax({
        type: "GET",
        url: "/st/user/setting/allApprovals/" + module_id,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                appendTableRowApproval(response.data.result, module_id);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}




function subApproval(module_id, permission_id) {


    $.ajax({
        type: "GET",
        url: "/st/user/setting/allSubApproval/" + module_id + '/' + permission_id,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                appendTableRowSubApproval(response.data.result, module_id, permission_id);
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}




function appendTableRowApproval(permissions, module_id) {

    $('#tblApproval').empty();
    for (i = 0; i < permissions.length; i++) {
        var id = permissions[i].permission_id;
        var count = permissions[i].sub_count;
        if (count != 0) {
            var name = permissions[i].name + ' (' + count + ')';
        } else {
            var name = permissions[i].name;
        }

        console.log(name);
        var slug = permissions[i].slug;
        var permission_string_id = "'" + id + "'";
        var module_string_id = "'" + module_id + "'";


        var sub_level = '<table><tbody id="tbl_sub_approval_' + id + '"></tbody></table>';
        $('#tblApproval').append('<tr><td><div><button id="btn_approval_' + id + '" class="btn btn-link"  onclick="subApproval(' + module_string_id + ',' + permission_string_id + ')">' + name + '</button></div><div>' + sub_level + '</div></td></tr>');

    }

}


function appendTableRowSubApproval(permissions, module_id, permission_id) {

    $('#tbl_sub_approval_' + permission_id).empty();
    for (i = 0; i < permissions.length; i++) {
        var id = permissions[i].permission_id;
        var count = permissions[i].sub_count;
        var is_approval = permissions[i].is_approval;
        if (count != 0) {
            var name = permissions[i].name + ' (' + count + ')';
        } else {
            var name = permissions[i].name;
        }


        var slug = permissions[i].id;
        var permission_string_id = "'" + id + "'";
        var module_string_id = "'" + module_id + "'";
        var action = permissions[i].action;
        var btnID = 'btnApproval' + slug;

        var approval = '';
        if (action && !is_approval) {
            alert('1');
            approval += '<button id="' + btnID + '" class="btn btn-primary" onclick="showApprovalModal(' + slug + ')">Set Approval</button>';
        } else if (action && is_approval) {
            alert('2');
            approval += '<button id="' + btnID + '" class="btn btn-success" onclick="showApprovalModal(' + slug + ')">Edit Approval</button>';
        }


        var sub_level = '<table><tbody id="tbl_sub_approval_' + id + '"></tbody></table>';
        $('#tbl_sub_approval_' + permission_id).append('<tr><td><div><button id="btn_approval_' + id + '" class="btn btn-link"  onclick="subApproval(' + module_string_id + ',' + permission_string_id + ')">' + name + '</button></div><div>' + sub_level + '</div></td><td  id="' + slug + '">' + approval + '</td></tr>');

    }
}


function showApprovalModal(slug) {

    var event = $('#btnApproval' + slug).text();
    $('#tblAddApprovalBody').empty();
    $('#txtMessage').val('');
    $('#txtDescription').val('');
    $('#btnApprovalAction').text('Save');
    if (event == 'Edit Approval') {
        getApproval(slug);
        $('#btnApprovalAction').text('Update');
    }
    $('#hidSlug').val(slug);
    $('#approvalModal').modal('toggle');
}


function hideApprovalModal() {
    $('#approvalForm').trigger("reset");
    $('#tblAddApprovalBody').empty();
    $('#btnAdd').prop("disabled", true);
    $('#approvalModal').modal('hide');
}

function addTableValue() {

    var id = "";
    var value = "";


    if ($('#checkDesignationSearch').is(':checked')) {
        id = $('#selcDesignation').val();
        value = $('select[name=designation] option:selected').text();
    }

    if ($('#checkUserSearch').is(':checked')) {
        id = $('#txtUser').optionID();
        value = $('#txtUser').val();
    }



    var rowID = createRowID(5);
    var row = document.createElement('tr');
    row.setAttribute('id', rowID);

    var col1 = document.createElement('td');
    var col2 = document.createElement('td');
    var col3 = document.createElement('td');



    var deleteBtn = document.createElement('button');
    deleteBtn.setAttribute('class', 'btn btn-danger');
    deleteBtn.setAttribute('type', 'button');
    deleteBtn.setAttribute('onclick', 'deleteRow("' + rowID + '")');
    deleteBtn.innerHTML = '<i class="fa fa-trash" aria-hidden="true"></i>';

    var priority = document.createElement('INPUT');
    priority.setAttribute('class', 'form-control');
    priority.setAttribute('type', 'text');
    priority.setAttribute('id', 'txtPriority');
    priority.setAttribute('name', 'priority');

    col1.innerText = value;
    col1.setAttribute('id', id);
    if ($('#checkDesignationSearch').is(':checked')) {
        col1.setAttribute('data-setting', "designation");
    }

    if ($('#checkUserSearch').is(':checked')) {
        col1.setAttribute('data-setting', "user");
    }

    col2.appendChild(priority);
    col3.appendChild(deleteBtn);

    row.appendChild(col1);
    row.appendChild(col2);
    row.appendChild(col3);
    $('#tblAddApprovalBody').append(row);
}




function createRowID(length) {
    var rowID = '';
    var characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var charactersLength = characters.length;
    for (var i = 0; i < length; i++) {
        rowID += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return rowID;
}

function allDesignation() {

    $.ajax({
        type: "GET",
        url: "/st/approval/allDesignation",
        async: false,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var designation = response.data.result;
                $.each(designation, function (index, value) {
                    $('#selcDesignation').append('<option value="' + value['designation_id'] + '">' + value['designation'] + '</option>');
                });

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}





function allEmployees() {

    $.ajax({
        type: "GET",
        url: "/st/approval/allEmployee",
        async: false,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var employees = response.data.result;
                $('#txtUser').setData(employees);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });

}


function deleteRow(id) {
    $('#' + id).remove();
}


function deleteApproval(id, approval_id) {


    $.ajax({
        type: 'DELETE',
        url: '/st/approval/delete/' + approval_id,
        data: {
            _token: $('input[name=_token]').val()
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage('Approval has been deleted successfully...');
                $('#' + id).remove();

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}



function isExistingValue(arg) {

    var table = document.getElementById('tblAddApproval');

    var rowLength = table.rows.length;
    var bool = false;
    for (var i = 1; i < rowLength; i += 1) {
        var row = table.rows[i];
        var value = row.cells[0].id;
        if (arg == value) {
            bool = true;
            break;
        }
    }
    return bool;
}



function getData() {
    var data = [];
    var table = document.getElementById('tblAddApproval');

    var rowLength = table.rows.length;
    for (var i = 1; i < rowLength; i += 1) {
        var row = table.rows[i];

        var id = row.cells[0].id;
        var setting = row.cells[0].getAttribute('data-setting');
        var priority = row.cells[1].firstChild.value;

        data.push({ 'id': id, 'setting': setting, 'priority': priority });


    }
    return data;
}



function getApproval(slug_id) {
    $.ajax({
        type: "GET",
        url: "/st/approval/getApproval/" + slug_id,
        async: false,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                $('#tblAddApprovalBody').empty();
                var approvals = response.data.result;
                for (i = 0; i < approvals.length; i++) {
                    $('#txtMessage').val(approvals[i].message);
                    $('#txtDescription').val(approvals[i].description);
                    if (approvals[i].user_id != null) {
                        var rowID = createRowID(5);
                        var stringRowID = "'" + rowID + "'";
                        var staringApprovalID = "'" + approvals[i].id + "'";
                        var row = '<tr id="' + rowID + '"><td id="' + approvals[i].user_id + '" data-setting="user">' + approvals[i].name + '</td><td><input type="text" class="form-control" id="txtPriority" value="' + approvals[i].prioraty + '"></td><td><button type="button" class="btn btn-danger" onclick="deleteApproval(' + stringRowID + ',' + staringApprovalID + ')"><i class="fa fa-trash" aria-hidden="true"></i></button></td></tr>';
                        $('#tblAddApprovalBody').append(row);
                    }
                    if (approvals[i].designation_id != null) {

                    }
                }

            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });


}


function saveApproval(data) {
    $.ajax({
        type: "POST",
        url: '/st/approval/saveApproval',
        async: false,
        data: {
            _token: $('input[name=_token]').val(),
            "slug": $('#hidSlug').val(),
            "description": $('#txtDescription').val(),
            "message": $('#txtMessage').val(),
            "data": data,
        },
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {
                showSuccessMessage('Module has been removed successfully...');
                var id = $('#hidSlug').val();
                var btnID = 'btnApproval' + id;
                $('#' + id).empty();
                $('#' + id).append('<button id="' + btnID + '" class="btn btn-success" onclick="showApprovalModal(' + id + ')">Edit Approval</button>');
                hideApprovalModal();

            } else {
                showErrorMessage();
            }


        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }

    });
}



function updateApproval(data) {

    $.ajax({
        type: 'PUT',
        url: '/st/approval/updateApproval',
        data: {
            _token: $('input[name=_token]').val(),
            "slug": $('#hidSlug').val(),
            "description": $('#txtDescription').val(),
            "message": $('#txtMessage').val(),
            "data": data,
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage('Approval has been updated successfully...');
                hideApprovalModal();

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });

}




/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}
