var role_id = 0;

$(document).ready(function () {
    var userRoleTable = $('#tblUserRole').DataTable({
        "scrollX": true,
        "order": [],
        "columns": [
            { "data": "id" },
            { "data": "user_role" },
            { "data": "edit", className: "edit" },
            { "data": "delete", className: "delete" },
        ],
        columnDefs: [
            { width: 100, targets: 0 },
            { width: 30, targets: 2 },
            { width: 30, targets: 3 },
        ],

    });


    allUserRole();


    $('#btnUserRoleAction').click(function () {
        var event = $('#btnUserRoleAction').text();
        if (event == 'Save') {
            saveUserRole();
        } else if (event == 'Update') {
            updateUserRole(role_id);
        }
    });








    $('#tblUserRole tbody').on('click', 'tr', function () {

        if ($(this).hasClass('selected')) {
            $(this).removeClass('selected');
        }
        else {
            userRoleTable.$('tr.selected').removeClass('selected');
            $(this).addClass('selected');

            var rowData = userRoleTable.row(this).data();
            role_id = rowData.id;
            allModules(role_id);
            $('#tblPermission').empty();

        }
    });





    $('#cmbModule').change(function () {
        var module_id = $('#cmbModule').val();
        allPermissions(role_id, module_id);
    });


});



function showUserRollModal() {
    $('#txtUserRole').val('');
    $('#btnUserRoleAction').text('Save');
    $('#userRoleModal').modal('toggle');
}


function closeUserRollModal() {
    $('#userRoleModal').modal('hide');
}


function editUserRole(id) {
    getUserRole(id);
}







/** Save user role */

function saveUserRole() {
    $.ajax({
        type: "POST",
        url: '/st/user/setting/saveUserRole',
        data: $('#userRoleForm').serialize(),
        processData: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage('UserRole has been saved successfully...');
                closeUserRollModal();
                allUserRole();

            } else {
                showErrorMessage();
            }


        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }

    });

}





/** Get user role from db */
function getUserRole(id) {
    $.ajax({
        type: "GET",
        url: "/st/user/setting/getUserRole/" + id,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var userRole = response.data.result;
                showUserRollModal();
                role_id = userRole.id;
                $('#txtUserRole').val(userRole.name);
                $('#btnUserRoleAction').text('Update');

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}




function deleteUserRole(id) {


    $.ajax({
        type: 'DELETE',
        url: '/st/user/setting/deleteUserRole/' + id,
        data: {
            _token: $('input[name=_token]').val()
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage('UserRole has been deleted successfully...');
                allUserRole();

            } else {
                showErrorMessage();
            }
        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}





/** Get all user role records from db */
function allUserRole() {
    $.ajax({
        type: "GET",
        url: "/st/user/setting/allUserRole",
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                appendTableRowUserRole(response.data.result);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}






function appendTableRowUserRole(result) {

    var data = [];
    for (i = 0; i < result.length; i++) {


        var id = result[i]['id'];
        var user_role = result[i]['name'];
        var string_id = "'" + id + "'";



        var switch_slider = '<label class="switch"><input type="checkbox" id=' + "swt" + id + ' name="status"   onchange="disable(' + string_id + ')"><span class="slider round"></span></label>';
        if (status == '1') {
            switch_slider = '<label class="switch"><input type="checkbox" id=' + "swt" + id + ' name="status" checked  onchange="disable(' + string_id + ')"><span class="slider round"></span></label>';
        }

        data.push({
            "id": id,
            "user_role": user_role,
            "edit": '<button class="btn btn-primary" onclick="editUserRole(' + id + ')"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>',
            "delete": '<button class="btn btn-danger" onclick="deleteUserRole(' + id + ')"><i class="fa fa-trash" aria-hidden="true"></i></button>',
        });

    }



    var table = $('#tblUserRole').DataTable();
    table.clear();
    table.rows.add(data).draw();
    table.columns('.edit').visible(false);
    table.columns('.delete').visible(false);



    if (edit_permission == 1) {
        table.columns('.edit').visible(true);
    }

    if (delete_permission == 1) {
        table.columns('.delete').visible(true);
    }

}






/** Update user role */
function updateUserRole(id) {

    $.ajax({
        type: 'PUT',
        url: '/st/user/setting/updateUserRole/' + id,
        data: $('#userRoleForm').serialize(),
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage('UserRole has been updated successfully...');
                closeUserRollModal();
                allUserRole();

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}




function allModules(role_id) {
    $.ajax({
        type: "GET",
        url: "/st/user/setting/allModules/" + role_id,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                appendTableRowModules(response.data.result);
                appendComboOption(response.data.result);
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}








function allPermissions(role_id, module_id) {
    $.ajax({
        type: "GET",
        url: "/st/user/setting/allPermissions/" + role_id + '/' + module_id,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                appendTableRowPermission(response.data.result, role_id, module_id);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}





function appendTableRowModules(result) {

    $('#tblModule').empty();
    for (i = 0; i < result.length; i++) {
        var id = result[i].id;
        var userRole_id = result[i].id;
        var assigned = result[i].assigned;
        var string_id = "'" + id + "'";
        var checked = '';
        if (assigned) {
            checked = 'checked';
        }

        $('#tblModule').append('<tr><td>' + result[i].name + '</td><td><div style="text-align: center;"><input type="checkbox" id="' + id + '" onclick="moduleChecked(' + string_id + ')" ' + checked + '></div></td></tr>');
    }

}







function appendTableRowPermission(permissions, role_id, module_id) {

    $('#tblPermission').empty();
    for (i = 0; i < permissions.length; i++) {
        var id = permissions[i].permission_id;
        var count = permissions[i].sub_count;
        if (count != 0) {
            var name = permissions[i].name + ' (' + count + ')';
        } else {
            var name = permissions[i].name;
        }

        console.log(name);
        var slug = permissions[i].slug;
        var allow = permissions[i].allow;
        var permission_string_id = "'" + id + "'";
        var role_string_id = "'" + role_id + "'";
        var module_string_id = "'" + module_id + "'";

        var checked = '';
        var disabled = 'disabled';
        if (allow) {
            checked = 'checked';
            disabled = '';
        }

        var sub_level = '<table><tbody id="tbl_sub_permission_' + id + '"></tbody></table>';
        $('#tblPermission').append('<tr><td><div><input type="checkbox" id="allow_' + id + '"  onclick="allowPermission(' + permission_string_id + ')" ' + checked + '><button id="btn_permission_' + id + '" class="btn btn-link"  onclick="subPermission(' + role_string_id + ',' + module_string_id + ',' + permission_string_id + ')" ' + disabled + '>' + name + '</button></div><div>' + sub_level + '</div></td></tr>');

    }

}





function subPermission(role_id, module_id, permission_id) {

    $.ajax({
        type: "GET",
        url: "/st/user/setting/allSubPermissions/" + role_id + '/' + module_id + '/' + permission_id,
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                appendTableRowSubPermission(response.data.result, role_id, module_id, permission_id);
            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}



function appendTableRowSubPermission(permissions, role_id, module_id, permission_id) {
    $('#tbl_sub_permission_' + permission_id).empty();
    for (i = 0; i < permissions.length; i++) {
        var id = permissions[i].permission_id;
        var count = permissions[i].sub_count;
        if (count != 0) {
            var name = permissions[i].name + ' (' + count + ')';
        } else {
            var name = permissions[i].name;
        }

        console.log(name);
        var slug = permissions[i].slug;
        var allow = permissions[i].allow;
        var permission_string_id = "'" + id + "'";
        var role_string_id = "'" + role_id + "'";
        var module_string_id = "'" + module_id + "'";

        var checked = '';
        var disabled = 'disabled';
        if (allow) {
            checked = 'checked';
            disabled = '';
        }
        var sub_level = '<table><tbody id="tbl_sub_permission_' + id + '"></tbody></table>';
        $('#tbl_sub_permission_' + permission_id).append('<tr><td><div><input type="checkbox" id="allow_' + id + '"  onclick="allowPermission(' + permission_string_id + ')" ' + checked + '><button id="btn_permission_' + id + '" class="btn btn-link"  onclick="subPermission(' + role_string_id + ',' + module_string_id + ',' + permission_string_id + ')" ' + disabled + '>' + name + '</button></div><div>' + sub_level + '</div></td></tr>');

    }
}





function moduleChecked(id) {

    if ($('#' + id).prop("checked")) {
        allowModule(id);
    } else {
        removeAllowedModule(id);
    }
}






function allowModule(id) {
    $.ajax({
        type: "POST",
        url: '/st/user/setting/allowModule',
        async: false,
        data: {
            _token: $('input[name=_token]').val(),
            "role_id": role_id,
            "module_id": id,
        },
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {
                showSuccessMessage('Module has been allowed successfully...');

            } else {
                showErrorMessage();
            }


        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }

    });
}







function allowPermission(id) {
    $.ajax({
        type: "POST",
        url: '/st/user/setting/allowPermission',
        async: false,
        data: {
            _token: $('input[name=_token]').val(),
            "user_id": "{{ Auth::user()->id }}",
            "role_id": role_id,
            "permission_id": id,
            "module_id": $('#cmbModule').val(),
            "allow": $('#allow_' + id).prop("checked"),
        },
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {
                if ($('#allow_' + id).prop("checked")) {
                    $('#btn_permission_' + id).prop('disabled', false);
                } else {
                    $('#btn_permission_' + id).prop('disabled', true);
                    $('#tbl_sub_permission_' + id).empty();
                }
                showSuccessMessage('Module has been allowed successfully...');

            } else {
                showErrorMessage();

            }


        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }

    });
}








function removeAllowedModule(id) {
    $.ajax({
        type: "POST",
        url: '/st/user/setting/removeAllowedModule',
        async: false,
        data: {
            _token: $('input[name=_token]').val(),
            "role_id": role_id,
            "module_id": id,
        },
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {
                showSuccessMessage('Module has been removed successfully...');

            } else {
                showErrorMessage();
            }


        },
        error: function (error) {
            console.log(error);

        },
        complete: function () {

        }

    });
}




function appendComboOption(result) {

    $('#cmbModule').empty();
    $('#cmbModule').append('<option value="disable" disabled>--Select Module--</option>');
    for (i = 0; i < result.length; i++) {
        $('#cmbModule').append('<option value="' + result[i].id + '">' + result[i].name + '</option>');
    }
    let element = document.getElementById('cmbModule');
    element.value = "disable";
}








/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}
