$(document).ready(function () {
    $('#tblUser').DataTable({
        "scrollX": true,
        "order": [],
        "columns": [
            { "data": "username" },
            { "data": "email" },
            { "data": "user_role" },
            { "data": "user_type" },
            { "data": "edit", className: "edit" },
            { "data": "delete", className: "delete" },
        ],
        columnDefs: [
            { width: 30, targets: 4 },
            { width: 30, targets: 5 },
        ],
    });

    allUser();

});




/** Get all user records from db */
function allUser() {
    $.ajax({
        type: "GET",
        url: "/st/user/allUser",
        processData: false,
        contentType: false,
        async: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                appendTableRow(response.data.result);

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });
}




function appendTableRow(result) {

    var data = [];
    for (i = 0; i < result.length; i++) {


        var role_id = result[i]['role_id'];
        var user_id = result[i]['user_id'];
        var name = result[i]['user_name'];
        var email = result[i]['email'];
        var user_role = result[i]['role_name'];
        var user_type = result[i]['user_type'];
        var string_role_id = "'" + role_id + "'";
        var string_user_id = "'" + user_id + "'";



        /*var switch_slider = '<label class="switch"><input type="checkbox" id=' + "swt" + id + ' name="status"   onchange="disable(' + string_id + ')"><span class="slider round"></span></label>';
        if (status == '1') {
            switch_slider = '<label class="switch"><input type="checkbox" id=' + "swt" + id + ' name="status" checked  onchange="disable(' + string_id + ')"><span class="slider round"></span></label>';
        }*/

        data.push({
            "username": name,
            "email": email,
            "user_role": user_role,
            "user_type": user_type,
            "edit": '<button class="btn btn-primary" onclick="edit(' + string_role_id + ',' + string_user_id + ')"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>',
            "delete": '<button class="btn btn-danger" onclick="_delete(' + string_user_id + ')"><i class="fa fa-trash" aria-hidden="true"></i></button>',
        });

    }



    var table = $('#tblUser').DataTable();
    table.clear();
    table.rows.add(data).draw();
    table.columns('.edit').visible(false);
    table.columns('.delete').visible(false);



    if (edit_permission == 1) {
        table.columns('.edit').visible(true);
    }

    if (delete_permission == 1) {
        table.columns('.delete').visible(true);
    }

}



function edit(role_id, user_id) {
    location.href = "/st/user?role_id=" + role_id + "&user_id=" + user_id + "&action=edit";
}



/** delete user */
function _delete(id) {

    $.ajax({
        type: 'DELETE',
        url: '/st/user/delete/' + id,
        data: {
            _token: $('input[name=_token]').val()
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                showSuccessMessage('User has been deleted successfully...');
                allUser();

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();
        },
        complete: function () {

        }

    });
}


/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage() {
    toastr.error('Something went wrong');
}
